<!--#INCLUDE FILE="config.asp"-->
<!--#INCLUDE FILE="inc_func_secure.asp" -->
<!--#INCLUDE FILE="inc_sha256.asp"-->
<!--#INCLUDE FILE="inc_header.asp" -->
<!--#INCLUDE FILE="inc_func_member.asp" -->
<!--#INCLUDE FILE="inc_func_common.asp" -->
<!--#include file="inc_photo_album_functions.asp"-->

<%
'#################################################################################
'## Copyright (C) 2000  Michael Anderson and Pierre Gorissen
'##
'## This program is free software; you can redistribute it and/or
'## modify it under the terms of the GNU General Public License
'## as published by the Free Software Foundation; either version 2
'## of the License, or any later version.
'##
'## All copyright notices regarding Snitz Forums 2000
'## must remain intact in the scripts and in the outputted HTML
'## The "powered by" text/logo with a link back to
'## http://forum.snitz.com in the footer of the pages MUST
'## remain visible when the pages are viewed on the internet or intranet.
'##
'## This program is distributed in the hope that it will be useful,
'## but WITHOUT ANY WARRANTY; without even the implied warranty of
'## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'## GNU General Public License for more details.
'##
'## You should have received a copy of the GNU General Public License
'## along with this program; if not, write to the Free Software
'## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'##
'## Support can be obtained from support forums at:
'## http://forum.snitz.com
'##
'## Correspondence and Marketing Questions can be sent to:
'## reinhold@bigfoot.com
'##
'## or
'##
'## Snitz Communications
'## C/O: Michael Anderson
'## PO Box 200
'## Harpswell, ME 04079
'#################################################################################

'#################################################################################
'# Instant Gallery v1.0 Mod by Daniele Lolli
'# Copyright 2004 (C) Daniele Lolli
'# This program is free software; you can redistribute it and/or
'# modify it under the terms of the GNU General Public License
'# as published by the Free Software Foundation; either version 2
'# of the License, or any later version.
'#
'# This program is distributed in the hope that it will be useful,
'# but WITHOUT ANY WARRANTY; without even the implied warranty of
'# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'# GNU General Public License for more details.
'#
'# You should have received a copy of the GNU General Public License
'# along with this program; if not, write to the Free Software
'# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'#
'# Mail me at: daniele.lolli@uncledan.it
'#
'##################################################################################
'# CREDITS: * The layout of this mod is based on the layout of the
'#                          Photo Album Mod by Wesley Brown
'#          * file inc_photo_album_functions.asp is required for the gfxSpex function
'# USAGE: just edit the configuration lines below and copy to your forum directory.
'#        All subfolders in the base folder are read as galleries, and the images
'#        inside them are shown. YOU DO NOT NEED A DATABASE, just upload the
'#        folders in the base dir. At the moment .jpg .jpeg and .gif images are
'#        supported. The configuration variables are:
'#        1) strBDir: base folder, absolute or relative. Special characters and "."
'#           are not allowed in folder names
'#        2) intThumbDim: max dimension of the thumb side. Size is adjusted to
'#           reflect images form factor
'#        3) intImagesPerRow: number of thumb images per row. Using a number of
'#           images different from 2, may require layout ajustment.
'# KNOWN PROBLEMS: * There must be at least one gallery (subfolder) in the base dir
'#                   (empty galleries are supported) and this MUST exist
'#                 * As galleries ARE folders, you can not use speciale characters
'#                   and dot character "." in the names
'# COMING SOON: * descriptions based on text file
'#              * paging
'#              * thumbs creation?
'#
'# NOTE: Remember that either galleries or images ARE SORTED BEFORE DISPLAYING!
'#
'#                THANK YOU FOR REPORTING IF YOU USE MY LITTLE MOD AT
'#                            daniele.lolli@uncledan.it
'#
'##################################################################################




'############## CONFIGURATION - Just change 3 lines below! (IF YOU NEED) ##############
strBDir = "/asp/sql/gallery/"
intThumbDim = 150
intImagesPerRow = 2
'######################################################################################

'################################### DEFINITIONS ######################################
Dim objFSO    'FileSystemObject variable
Dim objFolder 'Folder variable
Dim objItem   'Variable used to loop through the contents of the folders

'## For sort and filter
Dim rstImage, rstGallery, IntMaxIdGallery, IntIdShow, StrExtension, StrShow
Const adVarChar = 200
Const adInteger = 3
Const adDate = 7

'## Create FSO
Set objFSO = Server.CreateObject("Scripting.FileSystemObject")

'####################################### HEADER #######################################
'## Output Header - Start
response.write"<table border=""0"" width=""100%"">"& vbNewLine & _
	"  <tr>"& vbNewLine & _
	"    <td width=""100%"" align=""left"" nowrap><font face="""&strDefaultFontFace &""" size="""& strDefaultFontSize &""">"& vbNewLine & _
	"	" & getCurrentIcon(strIconFolderOpen,"","align=""absmiddle""") & "&nbsp;<a href=""default.asp"">All&nbsp;Forums</a><br>"& vbNewLine & _
	"	" & getCurrentIcon(strIconBar,"","align=""absmiddle""") & getCurrentIcon(strIconFolderOpenTopic,"","align=""absmiddle""") & "&nbsp;<a href=""instant_gallery.asp"">Instant Gallery</a><BR>"& vbNewLine & _
	"    </td>"& vbNewLine & _
	"    </tr>"& vbNewLine & _
	"    <tr>"& vbNewLine & _
	"    <td bgcolor=""" & StrHeadCellColor & """>"& vbNewLine & _
	"	&nbsp;"& vbNewLine & _
	"    </font></td>"& vbNewLine & _
	"  </tr>"& vbNewLine & _
	"</table>"& vbNewLine
'## Output Header - End

'################################### GALLERIES ########################################
'## Handle base dir
Set objFolder = objFSO.GetFolder(Server.MapPath(strBDir))

'## Scan subfolders = galleries
Set rstGallery = Server.CreateObject("ADODB.Recordset")
rstGallery.Fields.Append "id", adInteger
rstGallery.Fields.Append "name", adVarChar, 255
rstGallery.Fields.Append "date", adDate
rstGallery.Open

For Each objItem In objFolder.SubFolders
	rstGallery.AddNew
	rstGallery.Fields("name").Value = objItem.Name
	rstGallery.Fields("date").Value = objItem.DateCreated
Next 'objItem

'## Sort galleries
rstGallery.Sort = "name ASC, date ASC"

'## Assign id
intMaxIdGallery = 0
rstGallery.MoveFirst
Do While Not rstGallery.EOF
        intMaxIdGallery = intMaxIdGallery + 1
        rstGallery.Fields("id").Value = intMaxIdGallery
	rstGallery.MoveNext
Loop

'## Check gallery-to-show ID
If Request.QueryString("IDSHOW")="" then
   'If not specified I show first gallery
   IntIdShow = 1
ElseIf IsNumeric(Request.QueryString("IDSHOW")) = False then
       'If it's not numeric I show first gallery
       IntIdShow = 1
ElseIf (Request.QueryString("IDSHOW")) < 1 then
       'If it's out of the lower bound I show first gallery
       IntIdShow = 1
ElseIf cint(Request.QueryString("IDSHOW")) > intMaxIdGallery then
       'If it's out of the upper bound I show first gallery
       IntIdShow = 1
Else
    'Otherwise I check the gallery to show
    IntIdShow = cint(Request.QueryString("IDSHOW"))
End If

'## Find gallery-to-show name
StrShow = "*NOTHING*"
rstGallery.MoveFirst
Do While Not rstGallery.EOF
   If IntIdShow = rstGallery.Fields("id").Value then
      'If I found it I check the name
      StrShow =  rstGallery.Fields("name").Value
   End If
   rstGallery.MoveNext
Loop
If StrShow = "*NOTHING*" then
   'If everything goes wrong, I always show the first gallery
   rstGallery.MoveFirst
   StrShow =  rstGallery.Fields("name").Value
End If

'## Output Galleries - Start
'## Show galleries selection
Response.Write "<form action=""instant_gallery.asp"" method=""get"">"
Response.Write "<font face="""& strDefaultFontFace &""" size="""& strDefaultFontSize &""" color="""& strDefaultFontColor &""">" & vbNewLine & _
               "&nbsp;<b>Jump to gallery:</b>&nbsp;" & vbNewLine & _
               "<select name=""IDSHOW"" size=""1"">" & vbNewLine

rstGallery.MoveFirst
Do While Not rstGallery.EOF
   If rstGallery.Fields("id").Value = IntIDShow then
      'Select the shown gallery
      Response.Write "  <option selected value="""
   Else
      Response.Write "  <option value="""
   End If
   Response.Write rstGallery.Fields("id").Value & """>" & _
                  rstGallery.Fields("name").Value & "</option>" & vbNewLine
   rstGallery.MoveNext
Loop

Response.Write "</select>&nbsp;<input class=buttons type=""submit"" value=""View""></font>" & vbNewLine & _
               "</form>" & vbNewLine

Response.write "<p align=""center""><font face="""& strDefaultFontFace & """ size="""& strHeaderFontSize & _
               """ color=""" & strDefaultFontColor &""">" & strShow & "</font></p>"&VbnewLine

'Response.write "<p align=""center><h4> " & strShow &"  </h4></div>" & vbNewline

'Response.write"<div align = center> " & strGalleryDescription &"  </div>" & vbNewline


'## Output Galleries - End

'###################################### IMAGES ########################################
'## Handle subfolder = gallery
Set objFolder = objFSO.GetFolder(Server.MapPath(strBDir & strShow & "/"))

'## Scan files = images
Set rstImage = Server.CreateObject("ADODB.Recordset")
rstImage.Fields.Append "name", adVarChar, 255
rstImage.Fields.Append "date", adDate
rstImage.Fields.Append "width", adInteger
rstImage.Fields.Append "height", adInteger
rstImage.Open

For Each objItem In objFolder.Files
        strExtension = objItem.Name
	strExtension = LCase(Right(strExtension, Len(strExtension) - InStrRev(strExtension, ".", -1, 1)))
        Select Case strExtension
		Case "gif", "jpg", "jpeg"
                     rstImage.AddNew
	             rstImage.Fields("name").Value = objItem.Name
	             rstImage.Fields("date").Value = objItem.DateCreated
	             Set objItem = objFSO.GetFile(Server.MapPath(strBDir & StrShow & "/" & rstImage.Fields("name").Value))
	             If gfxSpex(objItem.Path, w, h, c, strExtension) = False then
	                rstImage.Fields("width").Value = 0
	                rstImage.Fields("height").Value = 0
	                'If I can't find I set null width and height
	             Else
      	                'I don't store depth, doesn't matter for my scope
                        rstImage.Fields("width").Value = w
	                rstImage.Fields("height").Value = h
	             End If
	             Set objItem = Nothing
		Case Else
                     'If it's not a recognized image I do nothing
	End Select
Next 'objItem

'## Release vars
Set objItem = Nothing
Set objFolder = Nothing
Set objFSO = Nothing

'## Sort images
rstImage.Sort = "name ASC, date ASC"

'## Output Images - Start
'Show images in the current gallery

Response.Write	"<table width=""100%""  border=""0"">"& vbNewLine & _
	"<tr>"& vbNewLine & _
	"<td>"& vbNewLine & _
	"<table width=""100%""  border=""0"">"& vbNewLine & _
	"<table border=""0"" width=""98%"" cellspacing=""0"" cellpadding=""0"" align=""center"">" & vbNewLine & _
	"  <tr>" & vbNewLine & _
	"    <td bgcolor=""" & strTableBorderColor & """>" & vbNewLine & _
	"    <table border=""0"" width=""100%"" cellspacing=""1"" cellpadding=""" & 2*intImagesPerRow & """>" & vbNewLine & _
	"      <tr>" & vbNewLine

For cntr = 1 to intImagesPerRow
    Response.Write "	<td align=center bgColor="""& strHeadCellColor &"""><b><font face="""& strDefaultFontFace &""" size="""& strDefaultFontSize &""" color="""& strHeadFontColor &""">Photo</font></b></td>"&VbnewLine &_
	           "        <td align=center bgColor="""& strHeadCellColor &"""><b><font face="""& strDefaultFontFace &""" size="""& strDefaultFontSize &""" color="""& strHeadFontColor &""">Description</font></b></td>"&VbnewLine
Next
Response.Write "      </tr>"&VbnewLine

If rstImage.BOF and rstImage.EOF then
         Response.write "<tr><td colspan = """ & 2*intImagesPerRow & """ align = ""center"" bgColor="""& strForumCellColor &""" width=""20%""><font face="""& strDefaultFontFace & _
                        """ size="""& strHeaderFontSize & """ color=""" & strDefaultFontColor &""">No images in this gallery</td></tr>"&VbnewLine
else

'# There are images - Start
rstImage.MoveFirst
cntr = 0
Do While Not rstImage.EOF
   cntr = cntr + 1
   if (cntr mod intImagesPerRow) = 1 then
      'First image of a row
      Response.Write"<TR>"&vbNewline
      end if
      width = rstImage.Fields("width").Value
      height = rstImage.Fields("height").Value
      if width > height then
         'landscape
         thumbwidth = intThumbDim
         thumbheight = cint(height / width * intThumbDim)
      elseif width < height then
             'portrait
             thumbheight = intThumbDim
             thumbwidth = cint(width / height* intThumbDim)
      else
          'square
          thumbwidth = intThumbDim
          thumbheight = intThumbDim
      end if
      strImage = strBdir & strShow & "/" & rstImage.Fields("name").Value
'I had some problems under Mozilla with the line below, so I replaced with a simplier <HREF="..." TARGET="_blank">
'     ref = "<A HREF= ""#"" onClick=""window.open('" & strImage & _
'           "','toolbar=no, width=" & width & ", height="& height &", left="& loffset &", top="& toffset &", screenX="& loffset &", screenY="& toffset &", status=no, scrollbars=no, resize=no');return false"">"
      ref = "<A HREF=""" & strImage & """ TARGET=""_blank"">"
      Response.Write"<td align = ""center"" bgcolor="""& strForumCellColor &""" width=""20%""><font face="""& strDefaultFontFace &""" size="""& strDefaultFontSize &""">"&VbnewLine
      Response.Write ref & "<IMG src="""& strImage & """ border=""1"" width = """ & thumbwidth & """ height = """ & thumbheight & """><br>" &vbNewline
      Response.Write "</a></font></td>"&vbNewline
      Response.write"<td align = ""center"" bgColor="""& strForumCellColor &""" width=""20%""><font face="""& strDefaultFontFace &""" size="""& strDefaultFontSize &""" color="""& strDefaultFontColor &""">No description<br />for this image</td>"&VbnewLine 'temp
      if (cntr mod intImagesPerRow) = 0 then
         'Last image of a row
         Response.Write"</TR>"&vbNewline
      end if
      rstImage.MoveNext
Loop

'fill empty cells
cntr = (cntr mod intImagesPerRow)
Do While cntr > 0
   Response.write"<td align = ""center"" bgColor="""& strForumCellColor &""" width=""20%""><font face="""& strDefaultFontFace &""" size="""& strDefaultFontSize &""" color="""& strHeadFontColor &""">&nbsp;</td>"&VbnewLine
   Response.write"<td align = ""center"" bgColor="""& strForumCellColor &""" width=""20%""><font face="""& strDefaultFontFace &""" size="""& strDefaultFontSize &""" color="""& strHeadFontColor &""">&nbsp;</td>"&VbnewLine
   cntr = cntr - 1
   if (cntr mod intImagesPerRow) = 0 then
      'Last image of a row
      Response.Write"</TR>"&vbNewline
   end if
   Loop

End If
'# There are images - End

Response.write "    </table>"&VbnewLine&_
               "    </td>"&VbnewLine&_
               "  </tr>"&VbnewLine&_
               "</table>"&VbnewLine&_
               "    </td>"&VbnewLine&_
               "  </tr>"&VbnewLine&_
               "</table><BR>"&VbnewLine
               'rap up the table

Call WriteFooter

'## Output Images - End

%>
